

#include <stdlib.h>
#include <stdio.h>

#include <time.h>   //pa manejar el tiempo
#include <unistd.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <signal.h>

#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>

#define BUFSIZE 1024
#define MAXHOSTNAME 80
#define max 100       //mximo de videos programados
#define maxvideo  40  //mximo de videos disponibles
//#define maxpaquet 10  //mximo de paquetes a enviar por vez.

typedef struct {          //aca se guardaran los datos de cada video programado
    int num_vid;
    char nombre[60];
    char mail[60];
	char maqrecp[60];
	char ubicacion[100];
    time_t horaini;
    time_t horaterm;
    time_t horamax;
    int duracion;   //duracion en segundos
    } ElemVideo;

typedef struct {     //lista que guardara los videos programados
  //  struct ElemVideo video[max];      ya no va  temporal
    ElemVideo video[max];
    int primero;
    int ultimo;
    } ListaVideo;

typedef struct {        //elementos del arreglo que cargara a videos.txt
	char nombre[60];
	char duracion[20];
	char ubicacion[100];
	} Video;

typedef struct {
	Video listaV[maxvideo];
    int cantidad; //cantidad de videos en la listaV
}VideoDisp;    //estructura con la lista de los videos programados

typedef struct {
	char buf[1024];
	int byte;
} Paquete;

time_t InHoramax();
time_t InsVideo( ListaVideo *listavideo, ElemVideo *elemvideo);
int VerVideo(ListaVideo *lista);
void cleanup(char *buf);

