
#include "cvs.h"                              

int main(int argc, char *argv[]) {

	int n,opc, fifo,pantalla;
	char buf[1024],eos[8],opchar[50];     //flag opchar
	FILE *archivo;
	pid_t srv_pid,pid;

	int   sd;
	struct   sockaddr_in server;
	struct  hostent *hp, *gethostbyname();
	struct  servent *sp;
	struct sockaddr_in from;
	struct sockaddr_in addr;
	int fromlen;
	int length;
	int rc, cc,u;
	char ThisHost[80];

	int y,h;
	VideoDisp videodisp;
	Video newvideo;
	ElemVideo videot;                 //almancena temporalmente el video a prog.
	ListaVideo videoprog;             //estructura con los videos programados
	time_t ttope;							 //tiempo max en seg.
	struct tm *ptm;
	char fecha[32];
    Paquete paquete;

	system("clear"); // Limpia la pantalla.

	if (argc!=3)    {
		printf("\nUsar: vcAdmin <host vcCS> <puerto vcAdmin> \n\n");
		return(-1);
	}

  /* get TCPClient Host information, NAME and INET ADDRESS */
 	gethostname(ThisHost, MAXHOSTNAME);

  	printf("----TCP/  cvAdmin arriba en el host: %s\n", ThisHost);
  	if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
    	fprintf(stderr, "Can't find host %s\n", ThisHost);
    	exit(-1);
  	}
  	bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
  	printf("    (TCP/ cvAdmin Internet Address: %s )\n", inet_ntoa(server.sin_addr));

  /* get TCP/Server Host information, NAME and INET ADDRESS */

  	if  ( (hp = gethostbyname(argv[1])) == NULL ) {  //si es NULL no tenemos argumento
    	addr.sin_addr.s_addr = inet_addr(argv[1]);     //y copia el host local
    	if ((hp = gethostbyaddr((void *)&addr.sin_addr.s_addr,
        	sizeof(addr.sin_addr.s_addr),AF_INET)) == NULL) { //retorna estruc hostent
      		fprintf(stderr, "Can't find host %s\n", argv[1]); // para la direccion dada(host)
      		exit(-1);
    	}
  	}
  	printf("----TCP/ cvServer running at host NAME: %s\n", hp->h_name);
  	bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);//copia de mem
  	printf("    (TCP/Server INET ADDRESS is: %s )\n", inet_ntoa(server.sin_addr));

  /* Construct name of socket to send to. */
  	server.sin_family = hp->h_addrtype;
  /* server.sin_family = AF_INET; */

  	server.sin_port = htons(atoi(argv[2]));//se copia el puerto
  /*OR    server.sin_port = sp->s_port; */                  /*HAY QUE CAP EL ERR*/

  /*   Create socket on which to send  and receive */

  	sd = socket (hp->h_addrtype,SOCK_STREAM,0);
  /*OR  sd = socket (HostAddress,SOCK_STREAM,PF_INET); */

  	if (sd<0) {
    	perror("opening stream socket");
    	exit(-1);
  	}
  /* Connect to TCP/SERVER */
  	if ( connect(sd, (struct sockaddr *)&server, sizeof(server)) < 0 ) {
    	close(sd);
    	perror("connecting stream socket");
    	exit(0);
  	}
  	fromlen = sizeof(from);
  	if (getpeername(sd, (struct sockaddr *)&from,&fromlen)<0){//obtiene el mombre de la pareja conectada
    	perror("could't get peername (server name)\n");
    	exit(1);
  	}
  	printf("Connected to TCP/ cvServer:");
 	printf("%s:%d\n", inet_ntoa(from.sin_addr),ntohs(from.sin_port));
   	if ((hp = gethostbyaddr((void *)&from.sin_addr.s_addr,
    					sizeof(from.sin_addr.s_addr),AF_INET)) == NULL)
    	fprintf(stderr, "Can't find host %s\n", inet_ntoa(from.sin_addr));
  	else
    	printf("(Name is : %s)\n", hp->h_name);


  /*     get data from USER, send it SERVER,
      receive it from SERVER, display it back to USER  */

///////////********************************************////////*
    setlinebuf(stdout); // cierra el buffer de stdout.


    cleanup(buf);
	printf("\n\n\nAdministrador del Servidor Remoto de Videos\n");

    while(1){

        printf("\nElija una opcin\n");                      //
        printf("1> Agregar un nuevo Video\n");                  //
        printf("2> Eliminar un Video de la lista\n");                   // ahora
		printf("3> Ver los Videos disponibles en la lista\n");
		printf("4> Ver los Videos Programados\n");
        printf("> Otra opcin para salir\n");

        scanf("%s",paquete.buf);
        opc=atoi(paquete.buf);
       
        switch (opc)   {
            case 1: { //Listar los videos.

				printf("Ingrese el nombre del video, en lugar de espacios utilice underscore'_'\n");
				fflush(stdout);
				scanf("%s",&newvideo.nombre);
				printf("Ingrese la duracin (minutos)\n");
				scanf("%s",&newvideo.duracion);
				printf("Ingrese la ubicacin en el sistema ej: /tmp/movie.mov\n");
				scanf("%s",&newvideo.ubicacion);
				printf("\n\n%2s %3s %s\n\n",newvideo.nombre,newvideo.duracion,newvideo.ubicacion);

                send(sd, "1",3,0); 		//se envia la opcin
				send(sd, (void *)&newvideo,sizeof(newvideo),0);

              //  printf("espero por recibir los datos\n");
               // fflush(stdout);
              //  if ((cc=read(sd, (void *)&videodisp, sizeof(videodisp))) < 0)
              //  perror("receiving echo");

            };break;

            case 2: {
				send(sd, "2",3,0); 		//se envia la opcin
				if ((cc=read(sd, (void *)&videodisp, sizeof(videodisp))) < 0)
					perror("receiving echo"); 			//recibo los videos en sist
				/*************************************************************************/
				printf("\n\nVideos Actualmente Disponibles\n\n");
				y=0;
				printf("N	     Nombre      Duracion(min)\n\n");
				while (y<videodisp.cantidad)	{
					printf("%2d %s  %s\n",y,videodisp.listaV[y].nombre,videodisp.listaV[y].duracion);
					y++;
				}
				/*************************************************************************/
				printf("Ingrese el nmero del video que desea eliminar");
				scanf("%s",paquete.buf);
				send(sd,(void *)&paquete,sizeof(paquete),0);//envia el N a eliminar

				};break;
			case 3: {
				send(sd, "3",3,0); 		//se envia la opcin
				if ((cc=read(sd, (void *)&videodisp, sizeof(videodisp))) < 0)
				perror("receiving echo");

				/*************************************************************************/
				;
				y=0;
				printf("\nN	     Nombre      Duracion(min)\n\n");
				while (y<videodisp.cantidad)	{
					printf("%2d %30s  %s\n",y,videodisp.listaV[y].nombre,videodisp.listaV[y].duracion);
					y++;
				}

				/*************************************************************************/
			};break;
			case 4: {
				send(sd, "4",3,0); 		//se envia la opcin
				if ((cc=read(sd, (void *)&videoprog, sizeof(videoprog))) < 0)
				perror("receiving echo");

				//Mostrar la lista en pantalla
				VerVideo(&videoprog);
			};break;

			default:    {
				printf("Gracias");
				close(sd);
                return(0);
            }
        } //switch
    }//while
  printf("EOF... exit\n");
  close(sd);
  return(0);

  }


//}


void cleanup(char *buf)
{
  int i;
  for(i=0; i<BUFSIZE; i++) buf[i]='\0';
 // printf("\nlimpie");
}
