#include "cvs.h"

int main(int argc, char *argv[]) {

	int n,opc, fifo,pantalla;
	char buf[1024],eos[8],opchar[3];
	FILE *archivo;
	pid_t srv_pid,pid;

	int   sd;
	struct   sockaddr_in server;
	struct  hostent *hp, *gethostbyname();
	struct  servent *sp;
	struct sockaddr_in from;
	struct sockaddr_in addr;
	int fromlen;
	int length;
	int rc, cc,u;
	char ThisHost[80];

	int y,h; 
	VideoDisp videodisp;
	Video videorec;
	ElemVideo videot;                 //almancena temporalmente el video a prog.
	time_t ttope;							 //tiempo max en seg.
	struct tm *ptm;
	char fecha[32];


	system("clear"); // Limpia la pantalla.
	if (argc!=3)    {
		printf("\nUsar: vcUser <host vcCs> <puerto vcUser> \n\n");
		return(-1);
	}


  /* get TCPClient Host information, NAME and INET ADDRESS */
 	gethostname(ThisHost, MAXHOSTNAME);

  	printf("----TCP/  cvClient arriba en el host: %s\n", ThisHost);
  	if  ( (hp = gethostbyname(ThisHost)) == NULL ) {
    	fprintf(stderr, "Can't find host %s\n", ThisHost);
    	exit(-1);
  	}
  	bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);
  	printf("    (TCP/ cvCleint Internet Address: %s )\n", inet_ntoa(server.sin_addr));

  /* get TCP/Server Host information, NAME and INET ADDRESS */

  	if  ( (hp = gethostbyname(argv[1])) == NULL ) {  //si es NULL no tenemos argumento
    	addr.sin_addr.s_addr = inet_addr(argv[1]);     //y copia el host local
    	if ((hp = gethostbyaddr((void *)&addr.sin_addr.s_addr,
        	sizeof(addr.sin_addr.s_addr),AF_INET)) == NULL) { //retorna estruc hostent
      		fprintf(stderr, "Can't find host %s\n", argv[1]); // para la direccion dada(host)
      		exit(-1);
    	}
  	}
  	printf("----TCP/ cvServer running at host NAME: %s\n", hp->h_name);
  	bcopy ( hp->h_addr, &(server.sin_addr), hp->h_length);//copia de mem
  	printf("    (TCP/Server INET ADDRESS is: %s )\n", inet_ntoa(server.sin_addr));

  /* Construct name of socket to send to. */
  	server.sin_family = hp->h_addrtype;
  /* server.sin_family = AF_INET; */

  	server.sin_port = htons(atoi(argv[2]));//se copia el puerto
  /*OR    server.sin_port = sp->s_port; */                  /*HAY QUE CAP EL ERR*/

  /*   Create socket on which to send  and receive */

  	sd = socket (hp->h_addrtype,SOCK_STREAM,0);
  /*OR  sd = socket (HostAddress,SOCK_STREAM,PF_INET); */

  	if (sd<0) {
    	perror("opening stream socket");
    	exit(-1);
  	}
  /* Connect to TCP/SERVER */
  	if ( connect(sd, (struct sockaddr *)&server, sizeof(server)) < 0 ) {
    	close(sd);
    	perror("connecting stream socket");
    	exit(0);
  	}
  	fromlen = sizeof(from);
  	if (getpeername(sd, (struct sockaddr *)&from,&fromlen)<0){//obtiene el mombre de la pareja conectada
    	perror("could't get peername (server name)\n");
    	exit(1);
  	}
  	printf("Connected to TCP/ cvServer:");
 	printf("%s:%d\n", inet_ntoa(from.sin_addr),ntohs(from.sin_port));
   	if ((hp = gethostbyaddr((void *)&from.sin_addr.s_addr,
    					sizeof(from.sin_addr.s_addr),AF_INET)) == NULL)
    	fprintf(stderr, "Can't find host %s\n", inet_ntoa(from.sin_addr));
  	else
    	printf("(Name is : %s)\n", hp->h_name);


  /*     get data from USER, send it SERVER,
      receive it from SERVER, display it back to USER  */

///////////********************************************////////*
    setlinebuf(stdout); // cierra el buffer de stdout.


    cleanup(buf);
	printf("\n\n\nBienvenido al Servidor Remoto de Videos\n");

    while(1){

        printf("\nElija una opcin\n");                      //
        printf("1> Ver lista de videos\n");                  //
        printf("2> Programar un Video\n");                   // ahora
        printf("> Otra opcin para salir\n");

        scanf("%s",opchar);
        opc=atoi(opchar);
//        opchar[3]='\0';
        printf("lei la opcion \n");     //flag

        switch (opc)   {
            case 1: { //Listar los videos.
        		send(sd, "1",3,0); 		//se envia la opcin
                printf("mensaje enviado\n");
				if ((cc=read(sd, (void *)&videodisp, sizeof(videodisp))) < 0)
                perror("receiving echo");

/*************************************************************************/
				printf("\n\n");
				y=0;
				printf("N	     Nombre      Duracion(min)\n\n");
				while (y<videodisp.cantidad)	{
					printf("%2d %s  %s\n",y,videodisp.listaV[y].nombre,videodisp.listaV[y].duracion);
					y++;
				}

/*************************************************************************/
            };break;


            case 2:     {
				printf("Programar un video\n");
				printf("\nIngrese el nmero de video\n");
				read(0,buf, sizeof(buf));
				videot.num_vid=atoi(buf);

				//ingreso de la hora max
				videot.horamax=InHoramax();     //captura la hora max a ser visto el video

                printf("Ingrese su correo (username) ");
                fflush(stdout);									//vacia el buffer de escritura.
                u=read(0,videot.mail, sizeof(videot.mail));
                videot.mail[u-1]='\0';
				printf("Ingrese el nombre de la mquina receptora ej: mateo.elo.utfsm.cl\n");
				scanf("%s",&videot.maqrecp);

				//manda videot que tiene todos los datos nec para la programacin

				send(sd, "2",3,0); 		//se envia la opcin
				printf("mandamos los datos\n");
				send(sd, (void *)&videot, sizeof(videot),0);

				read(sd, (void *)&ttope, sizeof(ttope)); //respuesta de la peticin

				if(ttope!=(-1)) { //el video fue programado
					printf("su video fue programado para el ");
					ptm=localtime(&ttope);
					strftime(fecha,sizeof(fecha),"%d/%m/%Y a las %H:%M hrs.\n",ptm);
					printf("%s\n",fecha);
				}
				else
				printf("su video no puede ser programado en ese horario\n");

			};break;

			default:    {
				printf("Gracias");
				close(sd);
				return(0);

              //  return(0);
            }
        } //switch
    }//while
  printf("EOF... exit\n");
  close(sd);
  return(0);

  }


//}


void cleanup(char *buf)
{
  int i;
  for(i=0; i<BUFSIZE; i++) buf[i]='\0';
 // printf("\nlimpie");
}
