/*
NAME:       TCPServer
SYNOPSIS:    TCPServer  [Port_number]
DESCRIPTION:  The program creates a TCP socket in the inet
             listen for connections from TCPClients, accept
             clients into private sockets. It uses select to attend
         clients' requests as they come.

*/

#include "cvs.h"

void reusePort(int sock);

main( int argc, char *argv[] )	{

	int   Suser, Sadmin,ss,sd;
	struct sockaddr_in server;
	struct sockaddr_in from;
	struct sockaddr_in addr;
	int fromlen;
	int length;
	struct  hostent *hx, *gethostbyname();
	struct  servent *sp;

	fd_set SockList, BackupList, SockList2;
	int n,i=0,rc;
	int sockuser[64], lastSock=0;		//lista de socket para los usuarios, una vez establecida la coneccin
	int sockadmin=0;						//socket usado por admin una vez establecida la coneccin
	int conectado=0;
	struct timeval tmuestreo={10,0};
    char opchar[50];
	int flaguser=0;  //flag para la desconeccin de usuarios
	char ThisHost[80];
	Paquete paquete;					//paquetes con info del video.
//	cont=0;								//contador de los paquetes enviados
	/************************************************************/

    int opc,pvideo,nvideo,x,y,h,u;/*boore un n*/
    char buf[1024],buf2[512],fecha[32],c; //pant
    FILE *archivo,*pfile;
	int arch;
    pid_t mypid;
    time_t ttope;							 //tiempo max en seg.
    struct tm fecha_pro={0,0,0,0,0,0,0,0};   //estructura que guardar temporalmente la fecha
    struct tm *ptm;                          // de programacion del video
    ListaVideo videoprog;             //estructura con los videos programados
    ElemVideo videot;                 //almancena temporalmente el video a prog.
    VideoDisp videodisp;              //el contenido de videos.txt se copia qui.
	Video newvideo;
	time_t actual;					  //tiene la hora actual.

    videoprog.primero=0;
    videoprog.ultimo=0;
    videoprog.video[videoprog.ultimo].horaterm=0;

	/*************************************************************/

	system("clear"); //limpia la pantalla

	if (argc!=4)    {
		printf("\nUsar: cvServer <puerto cvUser> <puerto cvAdmin> <puerto cvVRS>\n\n");
		return(-1);
	}

	/**************copia los videos a un arreglo*********************************/
	pfile=fopen("./videos.txt","r");
	x=0,y=0,h=0;

    while((fscanf(pfile,"%c",&c))!=EOF)	{
    	if((c!='^')&&(c!='\n')&&(h==1)) 	{//es parte del nombre
    		videodisp.listaV[y].nombre[x]=c;
    		x++;
    	}

    	if((c!='^')&&(c!='\n')&&(h==2)) 	{//es parte de la duracion
    		videodisp.listaV[y].duracion[x]=c;
    		x++;
    	}

    	if((c!='^')&&(c!='\n')&&(h==3)) 	{//es parte de la duracion
    		videodisp.listaV[y].ubicacion[x]=c;
    		x++;
    	}

    	if((c=='^')||(c=='\n'))	{
    		if(h==1){
    			videodisp.listaV[y].nombre[x]='\0';
    		}
    		if(h==2)	{
    			videodisp.listaV[y].duracion[x]='\0';
    		}
			if(h==3)
				videodisp.listaV[y].ubicacion[x]='\0';
    		h++;
    		x=0;
    	}

     	if(c=='\n')	{
     		h=0;
     		x=0;
     		y++;
     	}
     }
/****************************************************************************/

     videodisp.cantidad=y; //contiene cant de videos (indice del ltimo mas uno)
						   //nota parten de cero
/* Construct name of socket to send to. */
	server.sin_family = AF_INET;
	server.sin_addr.s_addr = htonl(INADDR_ANY);
	server.sin_port =htons(atoi(argv[1]));        //asignacion de puerto

	Suser = socket (AF_INET,SOCK_STREAM,0);
	reusePort(Suser);

	if ( bind( Suser, (struct sockaddr *)&server, sizeof(server) ) ) {
		close(Suser);
		perror("binding name to stream socket");
		exit(-1);
	}
	printf("vcUser  Server Port is: %d\n", ntohs(server.sin_port));

/*socket para el Administrador*/
	server.sin_port =htons(atoi(argv[2]));        //asignacion de puerto
	Sadmin = socket (AF_INET,SOCK_STREAM,0);
	reusePort(Sadmin);

	if ( bind( Sadmin, (struct sockaddr *)&server, sizeof(server) ) ) {
			close(Sadmin);
			perror("binding name to stream socket");
			exit(-1);
	}
	length = sizeof(server);
	if ( getsockname (Sadmin, (struct sockaddr *)&server,&length) ) {
    	perror("getting socket name");
    	exit(0);
	}
	printf("vcAdmin Server Port is: %d\n", ntohs(server.sin_port));
	printf("\nEsperando por conecciones\n");

	listen(Suser,4);   //declaran escuchar por los sockets
	listen(Sadmin,2);
	fromlen = sizeof(from);
	FD_ZERO(&BackupList);
	FD_SET(Suser,&BackupList);   //setean los socket a monitorear
	FD_SET(Sadmin,&BackupList);

	while(1)	{
		memcpy(&SockList, &BackupList, sizeof(SockList));  //copia la lista backup para la consulta
		tmuestreo.tv_sec=10;
		n = select(FD_SETSIZE, &SockList, (fd_set *) 0, (fd_set *) 0, &tmuestreo); //se muetrea cada 10 seg
		if (n > 0) {
			memcpy(&SockList2, &SockList, sizeof(SockList));  //flag no es necs
			if (FD_ISSET(Suser, &SockList)) {                //si es un usuario el que llego
				printf("Accepting a new connection...\n");   //se acepta la nueva conecion de usuario
				sockuser[lastSock] = accept(Suser, (struct sockaddr *)&from, &fromlen);
				read(Suser,buf,sizeof(buf));				// para limiar el buffer
				FD_SET(sockuser[lastSock], &BackupList);	//setea el nuevo socket de usuario activo
				lastSock++;
			}
			if (FD_ISSET(Sadmin, &SockList)) {              //si es un adminstrador, se acepta su coneccin
				printf("el admin llego\n");
				printf("Accepting a new Adminnistrator connection...\n");
				sockadmin = accept(Sadmin, (struct sockaddr *)&from, &fromlen);
				read(Suser,buf,sizeof(buf));			// para limiar el buffer
				FD_SET(sockadmin, &BackupList);//setea el nuevo socket activo
			}
			
/************************************* USUARIO *****************************************************/
			for (i=0; i < lastSock; i++) {    			//vemos si lleg la peticin usuario
				printf("pregunto cual sockuser last=%d i=%d\n",lastSock,i);
				if (FD_ISSET(sockuser[i], &SockList)) {
                    printf("voy a leer la opcion, i=%d\n\n",i);
                    fflush(stdout);
					if ( (rc=read(sockuser[i],(void *)&opchar, sizeof(opchar))) <= 0) { //
						printf("es un nuevo usuario, el N %d",i);						
						FD_CLR(sockuser[i], &BackupList);                       //
						sockuser[i] = sockuser[--lastSock];				        //Elimina los desconectados
						printf("Numero actual de Usuarios: %d\n", lastSock);	//de la lista de sockets abiertos
						i--;                                  					//
						flaguser=1;
					}

					if(flaguser==1)
						break;
					buf[rc]='\0';
					printf("\nMensaje recibido del socket %d (usuario)\n",sockuser[i]);
					printf("%s\n",opchar);

                    y=atoi(opchar);
                    switch(y)	{                    // se atienden los pedidos dependiendo de la opcin
						case 1:	{
      						printf("\nMandar la estrucura con  las pelculas disponibles\n");
							send(sockuser[i], (void *)&videodisp, sizeof(videodisp),0);

						};break;

						case 2: {					//programar un nuevo video

							//esperar la estructura con los datos
							read(sockuser[i], (void *)&videot, sizeof(videot)); //leo la estructura
							//agregamos los datos que faltan y estan disponibles en el sist
                            videot.duracion=atoi(videodisp.listaV[videot.num_vid].duracion)*60;
							strcpy(videot.nombre,videodisp.listaV[videot.num_vid].nombre);
							strcpy(videot.ubicacion,videodisp.listaV[videot.num_vid].ubicacion);

							ttope=InsVideo(&videoprog,&videot);//retorna hora en que se program el video
															   //envia -1 si no es posible
							send(sockuser[i], (void *)&ttope, sizeof(ttope),0);

                        } break;

						default:	{
							printf("opcion no valida\n");
						}

					}//switchr

				}//del primer if
				flaguser=0;
			}   //del for
			
/***********************************ADMINISTRADOR**********************************************/			
            printf("pregunto si llego el admin, sockadmin=%d\n",sockadmin);//flag
			if (FD_ISSET(sockadmin, &SockList)) {
                printf("si es el adminstrador\n");                        //flag
				if ( (rc=read(sockadmin, opchar, sizeof(opchar))) <= 0) { //vemos si el admin se desconect
					FD_CLR(sockadmin, &BackupList);                       //
					printf("\n\nSalio el adminstrador\n");    //
				}
				buf[rc]='\0';
				printf("\nMensaje recibido del socket %d (admin)\n",sockadmin);
				y=atoi(opchar);

				switch(y)	{

					case 1:	{
						printf("Agegar un nuevo video\n");
						read(sockadmin, (void *)&newvideo, sizeof(newvideo)); //obtiene el nuevo video

					/*Agrega el video al final de la lista existente*/
						videodisp.listaV[videodisp.cantidad]=newvideo;
						videodisp.cantidad++;

				/*********************************/
 				printf("\n\n");                       //se muestra en el servidor como quedo la nueva lista.

             	y=0;
             	printf("N	     Nombre      Duracion(min)\n\n");
             	while (y<videodisp.cantidad)	{
	             	printf("%2d %30s  %3s %s\n",y,videodisp.listaV[y].nombre,videodisp.listaV[y].duracion,videodisp.listaV[y].ubicacion);
    	         	y++;
    	         }                              /*temporal*/
				/********************************/
				printf("\nVideo aregado\n");
             		};break;

					case 2: {
						printf("eliminar un video de la lista\n");
						//manda los videos disponibles
						printf("mandar la estructura con  las peliculas disponibles\n");
						send(sockadmin, (void *)&videodisp, sizeof(videodisp),0);
						printf("esperando por el numero del video a borrar\n");
						rc=read(sockadmin,(void *)&paquete, sizeof(paquete)); //lee el N de video a eliminar
						paquete.buf[rc]='\0';
						y=atoi(paquete.buf);

						//Eliminar el video, se copia el ultimo en el lugar a eliminar.
						videodisp.listaV[y]=videodisp.listaV[videodisp.cantidad-1];
						videodisp.cantidad--;

						//No es necesario borrarlo realmente porque se desea no dejarlo disponible
						printf("Video eliminado de la lista\n");
					};break;

					case 3: {
						printf("mandar la estrucura con  las peliculas disponibles\n");
						send(sockadmin, (void *)&videodisp, sizeof(videodisp),0);
					};break;

					case 4: {
						printf("mandar la lista con los videos programados");
						send(sockadmin, (void *)&videoprog, sizeof(videoprog),0);
					};break;

					default:	{
						printf("opcin no valida\n");            //flag
					}
				}//switch
			} //del if FD_... que consulta por la llegada del admin.
 		} //n>0

		actual=time(NULL);//hora actual
 /******************************** MANDAR VIDEO ********************************/
		if(videoprog.video[videoprog.primero].horaini>=actual) {//vemos si es hora de mandar el video.
			//comprobamos si se ha establecido la coneccin
			if(!conectado) {  //si no esta conectado la establecemos
				//setear el socket


		 	/* TCP/Client (cvServer) Host information, NAME and INET ADDRESS */
				gethostname(ThisHost, MAXHOSTNAME);
				printf("----TCP/  cvServer arriba en el host: %s\n", ThisHost);
			if  ( (hx = gethostbyname(ThisHost)) == NULL ) {
    			fprintf(stderr, "No se puede encontrar el host %s\n", ThisHost);
				exit(-1);
			}
			bcopy ( hx->h_addr, &(server.sin_addr), hx->h_length);
			printf("    (TCP/ cvServer Internet Address: %s )\n", inet_ntoa(server.sin_addr));

  			/* get TCP/Server (Remote Host)Host information, NAME and INET ADDRESS */

			if  ( (hx = gethostbyname(videoprog.video[videoprog.primero].maqrecp) ) == NULL ) {
    			addr.sin_addr.s_addr = inet_addr(videoprog.video[videoprog.primero].maqrecp );
			if ((hx = gethostbyaddr((void *)&addr.sin_addr.s_addr,
    		   	sizeof(addr.sin_addr.s_addr),AF_INET)) == NULL) { 												  //retorna estruc hostent
				fprintf(stderr, "No se puede encontrar el host %s\n",videoprog.video[videoprog.primero].maqrecp); //para la direccion dada(host)
				exit(-1);
    			}
  			}
  			printf("----TCP/ cvVRS Server running at host NAME: %s\n", hx->h_name);
	  		bcopy ( hx->h_addr, &(server.sin_addr), hx->h_length);					//copia de mem
			printf("    (TCP/ cvVRS Server INET ADDRESS is: %s )\n", inet_ntoa(server.sin_addr));

		  /* Construct name of socket to send to. */
			server.sin_family = hx->h_addrtype;
			server.sin_port = htons(atoi(argv[3]));//se copia el puerto

 		 /*   Create socket on which to send  and receive */
			sd = socket (hx->h_addrtype,SOCK_STREAM,0);

			if (sd<0) {
    			perror("opening stream socket");
    			exit(-1);
			}
  			/* Connect to TCP/SERVER (vcVRS) */
			if ( connect(sd, (struct sockaddr *)&server, sizeof(server)) < 0 ) {//nos conectamos a vcVRS
    			close(sd);
    			perror("El servidor no se encuentra habilitado");
    			break;
			}
			fromlen = sizeof(from);
			if (getpeername(sd, (struct sockaddr *)&from,&fromlen)<0){//obtiene el mombre de la pareja conectada
	    		perror("could't get peername (server name)\n");
				exit(1);
			}
			printf("Connected to TCP/ cvVRS Server:");
			printf("%s:%d\n", inet_ntoa(from.sin_addr),ntohs(from.sin_port));
			if ((hx = gethostbyaddr((void *)&from.sin_addr.s_addr,
    						sizeof(from.sin_addr.s_addr),AF_INET)) == NULL)
    			fprintf(stderr, "Can't find host %s\n", inet_ntoa(from.sin_addr));
			else
    			printf("(Su nombre es : %s)\n", hx->h_name);


			strcpy(buf2,videoprog.video[videoprog.primero].nombre);   //ya conectados enviamos el nombre de la pelicula
			sprintf(buf,"uuencode -m %s /dev/stdout > ./codix",videoprog.video[videoprog.primero].ubicacion);
			printf("%s\n",buf);                                 //prepara el comando de codificacion.
			send(sd,(void *)&buf2,sizeof(buf2),0);              //se envia el nombre

			system(buf);                                        //codifica el archivo para enviarlo como char.
			arch=open("./codix",O_RDONLY);
			printf("Archivo abierto");
			//abrir el archivo
			conectado=1;
				//abrir el archivo

			}
		//enviar paquete, si termino el archivo conectado=0 cerrar archivo, desconectar
			if(conectado) {
				printf("Envio de paquetes del video\n");
//				cont=0;                                   //cero paquetes enviados
				while( (paquete.byte=read(arch,paquete.buf,sizeof(paquete.buf)))>0) {
					send(sd,(void *)&paquete,sizeof(paquete),0);
				}
				printf("\nArchivo enviado\n");
				close(arch);
				close(sd);
				system("rm ./codix");				//elimina el archivo temporal del sistema
				//envio el mail
				mail(&videoprog.video[videoprog.primero],1);
				//eliminarlo de la cola de videos
				videoprog.primero=(int)((videoprog.primero+1)%max);
				conectado=0;
			}//del if
		}

 		printf("."); //muetra  que el servidor no esta bloquedo
	} 	 //del while

}



void reusePort(int s)	{
	int one=1;

	if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 ) {
		printf("error in setsockopt,SO_REUSEPORT \n");
		exit(-1);
	}
}


/*deinir estrucura pa mandar videos*/



